bootcamp/news/urls.py
from django.conf.urls import url

from bootcamp.news import views

app_name = "news"
urlpatterns = [
    url(r"^$", views.NewsListView.as_view(), name="list"),
    url(
        r"^delete/(?P<pk>[-\w]+)/$", views.NewsDeleteView.as_view(), name="delete_news"
    ),
    url(r"^post-news/$", views.post_news, name="post_news"),
    url(r"^like/$", views.like, name="like_post"),
    url(r"^get-thread/$", views.get_thread, name="get_thread"),
    url(r"^post-comment/$", views.post_comment, name="post_comments"),
    url(
        r"^update-interactions/$", views.update_interactions, name="update_interactions"
    ),
]

bootcamp/qa/urls.py
from django.conf.urls import url

from bootcamp.qa import views

app_name = "qa"
urlpatterns = [
    url(r"^$", views.QuestionListView.as_view(), name="index_noans"),
    url(r"^answered/$", views.QuestionAnsListView.as_view(), name="index_ans"),
    url(r"^indexed/$", views.QuestionsIndexListView.as_view(), name="index_all"),
    url(
        r"^question-detail/(?P<pk>\d+)/$",
        views.QuestionDetailView.as_view(),
        name="question_detail",
    ),
    url(r"^ask-question/$", views.CreateQuestionView.as_view(), name="ask_question"),
    url(
        r"^propose-answer/(?P<question_id>\d+)/$",
        views.CreateAnswerView.as_view(),
        name="propose_answer",
    ),
    url(r"^question/vote/$", views.question_vote, name="question_vote"),
    url(r"^answer/vote/$", views.answer_vote, name="answer_vote"),
    url(r"^accept-answer/$", views.accept_answer, name="accept_answer"),
]

bootcamp/users/urls.py
from django.conf.urls import url

from . import views

app_name = "users"
urlpatterns = [
    url(regex=r"^$", view=views.UserListView.as_view(), name="list"),
    url(regex=r"^~redirect/$", view=views.UserRedirectView.as_view(), name="redirect"),
    # url(regex=r"^~update/$", view=views.UserUpdateView.as_view(), name="update"),
    url(
        regex=r"^(?P<username>[\w.@+-]+)/$",
        view=views.UserDetailView.as_view(),
        name="detail",
    ),
    url(
        regex=r'^~validate/$',
        view=views.UserValidationView.as_view(),
        name='validate'
    ),
    url(
        regex=r'^~logout/$',
        view=views.FCMLogoutView.as_view(),
        name='fcm_logout'
    ),
    url(
        regex=r'^~logoutall/$',
        view=views.FCMLogoutAllView.as_view(),
        name='fcm_logoutall'
    ),
    url(
        regex=r'^~location/$',
        view=views.UpdateLocationView.as_view(),
        name='update_location'
    ),
    url(
        regex=r'^~fcmtoken/$',
        view=views.RegistrationToken.as_view(),
        name='token-detail'
    ),
]

quiz/urls.py
from django.conf.urls import url

from . import views

app_name = 'quiz'
urlpatterns = [
    url(r'^course/(?P<course>[\w-]+)/$', views.LoadQuizes.as_view(), name='quizes'),
    url(r'^course/(?P<course>[\w-]+)/(?P<slug>[\w-]+)/$', views.LoadQuiz.as_view(), name='quiz'),
    url(r'^activity/$', views.SaveActivity.as_view(), name='save_activity'),
]

bootcamp/articles/forms.py
from django import forms

from markdownx.fields import MarkdownxFormField

from bootcamp.articles.models import Article


class ArticleForm(forms.ModelForm):
    status = forms.CharField(widget=forms.HiddenInput())
    edited = forms.BooleanField(
        widget=forms.HiddenInput(), required=False, initial=False
    )
    content = MarkdownxFormField()

    class Meta:
        model = Article
        fields = ["title", "content", "image", "tags", "status", "edited"]

bootcamp/qa/forms.py
from django import forms

from markdownx.fields import MarkdownxFormField

from bootcamp.qa.models import Answer, Question


class QuestionForm(forms.ModelForm):
    status = forms.CharField(widget=forms.HiddenInput())
    content = MarkdownxFormField()

    class Meta:
        model = Question
        fields = ["title", "content", "tags", "status"]

bootcamp/articles/views.py
from django.contrib import messages
from django.contrib.auth.mixins import LoginRequiredMixin
from django.views.generic import CreateView, ListView, UpdateView, DetailView
from django.urls import reverse
from django.utils.translation import ugettext_lazy as _

from bootcamp.helpers import AuthorRequiredMixin
from bootcamp.articles.models import Article
from bootcamp.articles.forms import ArticleForm


class ArticlesListView(LoginRequiredMixin, ListView):
    """Basic ListView implementation to call the published articles list."""

    model = Article
    paginate_by = 15
    context_object_name = "articles"

    def get_context_data(self, *args, **kwargs):
        context = super().get_context_data(*args, **kwargs)
        context["popular_tags"] = Article.objects.get_counted_tags()
        return context

    def get_queryset(self, **kwargs):
        return Article.objects.get_published()


class DraftsListView(ArticlesListView):
    """Overriding the original implementation to call the drafts articles
    list."""

    def get_queryset(self, **kwargs):
        return Article.objects.get_drafts()


class CreateArticleView(LoginRequiredMixin, CreateView):
    """Basic CreateView implementation to create new articles."""

    model = Article
    message = _("Your article has been created.")
    form_class = ArticleForm
    template_name = "articles/article_create.html"

    def form_valid(self, form):
        form.instance.user = self.request.user
        return super().form_valid(form)

    def get_success_url(self):
        messages.success(self.request, self.message)
        return reverse("articles:list")


class EditArticleView(LoginRequiredMixin, AuthorRequiredMixin, UpdateView):
    """Basic EditView implementation to edit existing articles."""

    model = Article
    message = _("Your article has been updated.")
    form_class = ArticleForm
    template_name = "articles/article_update.html"

    def form_valid(self, form):
        form.instance.user = self.request.user
        return super().form_valid(form)

    def get_success_url(self):
        messages.success(self.request, self.message)
        return reverse("articles:list")


class DetailArticleView(LoginRequiredMixin, DetailView):
    """Basic DetailView implementation to call an individual article."""

    model = Article

bootcamp/messager/views.py
from django.db.models import Count, Q
from django.shortcuts import get_object_or_404

from bootcamp.messager import models
from bootcamp.messager import serializers
from bootcamp.messager.fcm import send_event_via_fcm

from rest_framework.response import Response
from rest_framework.views import APIView
from rest_framework import status

from itertools import chain

class LoadInbox(APIView):

    def get(self, request):
        """Load user inbox threads

        - Retrieve all of the threads that includes the user in the clients field.
        - count number of unread messages using related name receipts containing user
        - returns {"threads":[thread]}
        """
        threads = models.MessageThread.objects.filter(clients=request.user, is_active=True, membership__archived=False).annotate(
            unread_count=Count('receipts',filter=Q(receipts__recipient=request.user))
        )
        if request.user.is_superuser:
            threads2 = models.MessageThread.objects.filter(clients=request.user, is_active=True, membership__archived=True).annotate(
                unread_count=Count('receipts',filter=Q(receipts__recipient=request.user))
            ).exclude(unread_count=0)
            threads = chain(threads,threads2)
        thread_data = serializers.MessageThreadListSerializer(threads).data
        return Response({'threads':thread_data})


class LoadMessages(APIView):

    def get(self, request):
        """Load messages from thread

        - Load 30 messages by default.
        - The 'before' parameter will load the previous 30 messages relative to the date.
        - returns json {messages:[message], end:bool}
        """
        thread = models.MessageThread.objects.get(uuid_id=request.GET['id'])
        # make sure we are part of this chat before we read the messages
        if not request.user in thread.clients.all():
            return Response(status=403)
        # query for messages filter
        q = [Q(thread=thread)]
        if 'before' in request.GET:
            q.append(Q(id__lt=int(request.GET['before'])))
        # query messages matching filter
        messages = models.Message.objects.filter(*q)
        messages_data = serializers.MessageListSerializer(messages[:30]).data
        # mark any unread messages in chat as read
        thread.mark_read(request.user)
        return Response({"messages":messages_data,"end":messages.count() <= 30})


class EditMembership(APIView):

    def get(self, request):
        membership = get_object_or_404(models.Membership, user=request.user, messagethread=request.POST.get("id", ""))
        action = request.POST.get("action", "")
        if action == 'archive':
            membership.archived = True
            membership.save()
            return Response(status=status.HTTP_202_ACCEPTED)
        elif action == 'mute':
            membership.notification_on = False
            membership.save()
            return Response(status=status.HTTP_202_ACCEPTED)
        elif action == 'unmute':
            membership.notification_on = False
            membership.save()
            return Response(status=status.HTTP_202_ACCEPTED)
        elif action == 'accept':
            TEXT = "We are delighted to tell you that you are now off the waitlist. Now before you start swiping, just make sure you have one holiday picture and don't shy from mentioning your job/company/college."
            membership.messagethread.add_message_text(TEXT,request.user)
            notification_serialized = {
                        "message_title":"Kudos 😃",
                        "message_body":"Your can now start swiping.",
                        "thread_id":str(membership.messagethread.uuid_id),
                        "peer_display_name":str(request.user.name),
                        "peer_id":str(request.user.id),
                        "peer_avatar":str(request.user.avatar),
                    }
            for client in membership.messagethread.clients.exclude(id=request.user.id):
                try:
                    client.is_new = True
                    client.save()
                    send_event_via_fcm(client, notification_serialized)
                except:
                    pass
            membership.archived = True
            membership.save()
            return Response(status=status.HTTP_202_ACCEPTED)
        elif action == 'reject':
            for client in membership.messagethread.clients.exclude(id=request.user.id):
                try:
                    client.is_new = False
                    client.save()
                except:
                    pass
            membership.archived = True
            membership.save()
            return Response(status=status.HTTP_202_ACCEPTED)
        return Response(status=status.HTTP_400_BAD_REQUEST)

bootcamp/news/views.py
from django.contrib.auth.decorators import login_required
from django.contrib.auth.mixins import LoginRequiredMixin
from django.http import HttpResponse, HttpResponseBadRequest, JsonResponse
from django.template.loader import render_to_string
from django.urls import reverse_lazy
from django.utils.translation import ugettext_lazy as _
from django.views.decorators.http import require_http_methods
from django.views.generic import ListView, DeleteView

from bootcamp.helpers import ajax_required, AuthorRequiredMixin
from bootcamp.news.models import News


class NewsListView(LoginRequiredMixin, ListView):
    """A really simple ListView, with some JS magic on the UI."""

    model = News
    paginate_by = 15

    def get_queryset(self, **kwargs):
        return News.objects.filter(reply=False)


class NewsDeleteView(LoginRequiredMixin, AuthorRequiredMixin, DeleteView):
    """Implementation of the DeleteView overriding the delete method to
    allow a no-redirect response to use with AJAX call."""

    model = News
    success_url = reverse_lazy("news:list")


@login_required
@ajax_required
@require_http_methods(["POST"])
def post_news(request):
    """A function view to implement the post functionality with AJAX allowing
    to create News instances as parent ones."""
    user = request.user
    post = request.POST["post"]
    post = post.strip()
    if 0 < len(post) <= 280:
        posted = News.objects.create(user=user, content=post)
        html = render_to_string(
            "news/news_single.html", {"news": posted, "request": request}
        )
        return HttpResponse(html)

    else:
        length = len(post) - 280
        return HttpResponseBadRequest(
            content=_(f"Text is {length} characters longer than accepted.")
        )


@login_required
@ajax_required
@require_http_methods(["POST"])
def like(request):
    """Function view to receive AJAX, returns the count of likes a given news
    has recieved."""
    news_id = request.POST["news"]
    news = News.objects.get(pk=news_id)
    user = request.user
    news.switch_like(user)
    return JsonResponse({"likes": news.count_likers()})


@login_required
@ajax_required
@require_http_methods(["GET"])
def get_thread(request):
    """Returns a list of news with the given news as parent."""
    news_id = request.GET["news"]
    news = News.objects.get(pk=news_id)
    news_html = render_to_string("news/news_single.html", {"news": news})
    thread_html = render_to_string(
        "news/news_thread.html", {"thread": news.get_thread(), "request": request}
    )
    return JsonResponse({"uuid": news_id, "news": news_html, "thread": thread_html})


@login_required
@ajax_required
@require_http_methods(["POST"])
def post_comment(request):
    """A function view to implement the post functionality with AJAX, creating
    News instances who happens to be the children and commenters of the root
    post."""
    user = request.user
    post = request.POST["reply"]
    par = request.POST["parent"]
    parent = News.objects.get(pk=par)
    post = post.strip()
    if post:
        parent.reply_this(user, post)
        return JsonResponse({"comments": parent.count_thread()})

    else:
        return HttpResponseBadRequest()


@login_required
@ajax_required
@require_http_methods(["POST"])
def update_interactions(request):
    data_point = request.POST["id_value"]
    news = News.objects.get(pk=data_point)
    data = {"likes": news.count_likers(), "comments": news.count_thread()}
    return JsonResponse(data)

bootcamp/notifications/views.py
from django.contrib import messages
from django.contrib.auth.decorators import login_required
from django.contrib.auth.mixins import LoginRequiredMixin
from django.shortcuts import get_object_or_404, redirect, render
from django.utils.translation import ugettext_lazy as _
from django.views.generic import ListView

from bootcamp.notifications.models import Notification


class NotificationUnreadListView(LoginRequiredMixin, ListView):
    """Basic ListView implementation to show the unread notifications for
    the actual user"""

    model = Notification
    context_object_name = "notification_list"
    template_name = "notifications/notification_list.html"

    def get_queryset(self, **kwargs):
        return self.request.user.notifications.unread()


@login_required
def mark_all_as_read(request):
    """View to call the model method which marks as read all the notifications
    directed to the actual user."""
    request.user.notifications.mark_all_as_read()
    _next = request.GET.get("next")
    messages.add_message(
        request,
        messages.SUCCESS,
        _(f"All notifications to {request.user.username} have been marked as read."),
    )

    if _next:
        return redirect(_next)

    return redirect("notifications:unread")


@login_required
def mark_as_read(request, slug=None):
    """View to call the model method which mark as read the provided
    notification."""
    if slug:
        notification = get_object_or_404(Notification, slug=slug)
        notification.mark_as_read()

    messages.add_message(
        request,
        messages.SUCCESS,
        _(f"The notification {notification.slug} has been marked as read."),
    )
    _next = request.GET.get("next")

    if _next:
        return redirect(_next)

    return redirect("notifications:unread")


@login_required
def get_latest_notifications(request):
    notifications = request.user.notifications.get_most_recent()
    return render(
        request, "notifications/most_recent.html", {"notifications": notifications}
    )

bootcamp/templates/news/news_confirm_delete.html
{% extends "base.html" %}

{% load i18n %}

{% block head_title %}{% trans "Delete news" %}{% endblock %}

{% block content %}
<h1>{% trans "Delete a posted news" %}</h1>

<p>{% trans 'Are you sure you want to continue? If you do this you will delete this news' %}</p>

<form method="post" action="{% url 'news:delete_news' news.pk %}">
  {% csrf_token %}
  <button class="btn btn-danger" type="submit">{% trans 'Delete' %}</button>
</form>


{% endblock %}

bootcamp/templates/news/news_form_modal.html
{% load i18n %}

<div class="modal fade" id="newsFormModal" tabindex="-1" role="dialog" aria-labelledby="newsFormModalTitle" aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title">{% trans "Share something new!" %}</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
        <form id="postNewsForm" role="form" method="post" action="#" onsubmit="return false">
          {% csrf_token %}
          <div class="form-group">
            <textarea id="newsInput" name="post" rows="3" class="form-control" maxlength="280"></textarea>
            <span id="newsCounter" class="pull-right">280</span>
          </div>
        </form>
      </div>
      <div class="modal-footer">
        <button type="button" id="postNews" class="btn btn-primary">
          <i class="fa fa-paper-plane" aria-hidden="true"></i> {% trans 'Post' %}
        </button>
        <button type="button" class="btn btn-default" data-dismiss="modal">{% trans 'Cancel' %}</button>
      </div>
    </div>
  </div>
</div>

bootcamp/templates/news/news_list.html
{% extends 'base.html' %}
{% load static i18n humanize %}
{% load thumbnail %}


{% block head %}
  <link href="{% static 'css/news.css' %}?v=1" rel="stylesheet">
{% endblock head %}


{% block content %}
    <!-- Container -->
    <div class="container">
      <div class="row">
        <div class="col-md-3">
          <h1>{% trans 'News' %}</h1>
          <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#newsFormModal">
            <i class="fa fa-share-alt" aria-hidden="true"></i> {% trans 'Share something' %}
          </button>
        </div>
        <div class="col-md-6">
          <div>
            <h3>{% trans 'Most Recent Posts' %}</h3>
          </div>

          <!-- Modals -->
          {% include 'news/news_form_modal.html' %}
          {% include 'news/news_thread_modal.html' %}
          <!-- End Modals -->

          <!-- News List -->
          <div class="stream-update">
            <a href="{% url 'news:list' %}"><span class="new-posts"></span> {% trans 'There are new posts' %}</a>
          </div>
          <div class="infinite-container">
            <ul class="stream">
              {% for news in news_list %}
                {% include 'news/news_single.html' with news=news %}
              {% endfor %}
            </ul>
          </div>
          <div class="load">
            {% if page_obj.has_next %}
              <a class="infinite-more-link" href="?page={{ page_obj.next_page_number }}"><img src="{% static 'img/loading.gif' %}"></a>
            {% endif %}
          </div>
          <!-- End News List -->
        </div>
      </div>
    </div>
    <!-- End container -->

{% endblock content %}

{% block modal %}
  <script src="{% static 'js/jquery.waypoints.min.js' %}" type="text/javascript"></script>
  <script src="{% static 'js/infinite.min.js' %}" type="text/javascript"></script>
  <script src="{% static 'js/news.js' %}" type="text/javascript"></script>
  <script>
    var infinite = new Waypoint.Infinite({
      element: $('.infinite-container')[0],
      onBeforePageLoad: function () {
        $('.load').show();
      },
      onAfterPageLoad: function ($items) {
        $('.load').hide();
      }
    });
  </script>
{% endblock modal %}

bootcamp/templates/news/news_single.html
{% load i18n %}
{% load humanize static %}
{% load thumbnail %}
{% load urlize_target_blank %}

<li class="infinite-item card" news-id="{{ news.uuid_id }}">
  <div class="card-body">
    <div class="profile-picture">
      {% thumbnail news.user.picture "x60" as im %}
        <img src="{{ im.url }}" class="pull-left" style="border-radius: 50%;" alt="{% trans 'User Image' %}" class="user-image">
      {% empty %}
        <img src="{% static 'img/user.png' %}" class="pull-left" height="60px" alt="{% trans 'No Profile Picture' %}" />
      {% endthumbnail %}
    </div>
    <div class="post">
      {% if news.user == request.user %}
        <a href="{% url 'news:delete_news' news.pk %}">
          <i class="fa fa-times pull-right" aria-hidden="true" title="{% trans 'Click to remove this news' %}"></i>
        </a>
      {% endif %}
      <p>
        <strong>
          <a href="{% url 'users:detail' news.user.username  %}">{{ news.user.get_profile_name|title }}</a>
        </strong>
      </p>
      <p>{{ news|urlize|urlize_target_blank }}</p>
      
      {% if news.meta_url %}
        <a href="{{ news.meta_url }}" target="_blank" class="card meta">
          {% if news.meta_image %}
            <div class="card-img-top" style="background-image: url({{ news.meta_image }})"></div>
          {% endif %}
          <div class="card-body">
            {% if news.meta_title %}
              <h5 class="card-title">{{ news.meta_title }}</h5>
            {% endif %}
            {% if news.meta_description %}
              <p class="card-text">{{ news.meta_description }}</p>
            {% endif %}
            {% if news.meta_url %}
              <p class="card-btn">{{ news.meta_url }}</p>
            {% endif %}
          </div>
        </a>
      {% endif %}
      <div class="interaction" id="interaction">
        <a href="#" class="like" title="{% for i in news.get_likers %}{{ i }}&#10;{% endfor %}">
          {% if request.user in news.get_likers %}
            <i class="heart fa fa-heart" aria-hidden="true"></i>
          {% else %}
            <i class="heart fa fa-heart-o" aria-hidden="true"></i>
          {% endif %}
          <span class="like-count">{{ news.count_likers }}</span>
        </a>
        <a href="#" class="comment"><i class="fa fa-comment-o" aria-hidden="true"></i>
          <span class="comment-count">{{ news.count_thread }}</span>
        </a>
        <span class="timestamp">{{ news.timestamp|naturaltime }}</span>
      </div>
    </div>
  </div>
</li>

bootcamp/templates/news/news_thread.html
{% load i18n %}
{% load humanize static %}
{% load thumbnail %}
{% load urlize_target_blank %}


{% for reply in thread %}
  <li class="card" news-id="{{ reply.uuid_id }}">
    <div class="card-body">
      <div class="profile-picture">
        {% thumbnail reply.user.picture "x60" as im %}
          <img src="{{ im.url }}" class="pull-left" style="border-radius: 50%;" alt="{% trans 'User Image' %}" class="user-image">
        {% empty %}
          <img src="{% static 'img/user.png' %}" class="pull-left" height="60px" alt="{% trans 'No Profile Picture' %}" />
        {% endthumbnail %}
      </div>
      <div class="post">
        {% if reply.user == request.user %}
          <a href="{% url 'news:delete_news' reply.pk %}">
            <i class="fa fa-times pull-right" aria-hidden="true" title="{% trans 'Click to remove this news' %}"></i>
          </a>
        {% endif %}
        <p>
          <strong>
            <a href="{% url 'users:detail' reply.user.username  %}">{{ reply.user.get_profile_name|title }}</a>
          </strong>
        </p>
        <p>{{ reply|urlize|urlize_target_blank }}</p>
        {% if reply.meta_url %}
          <a href="{{ reply.meta_url }}" target="_blank" class="card meta">
            {% if reply.meta_image %}
              <div class="card-img-top" style="background-image: url({{ reply.meta_image }})"></div>
            {% endif %}
            <div class="card-body">
              {% if reply.meta_title %}
                <h5 class="card-title">{{ reply.meta_title }}</h5>
              {% endif %}
              {% if reply.meta_description %}
                <p class="card-text">{{ reply.meta_description }}</p>
              {% endif %}
              {% if reply.meta_url %}
                <p class="card-btn">{{ reply.meta_url }}</p>
              {% endif %}
            </div>
          </a>
        {% endif %}
        <div class="interaction" id="interaction">
          <a href="#" class="like" title="{% for i in news.get_likers %}{{ i }}&#10;{% endfor %}">
            {% if request.user in news.get_likers %}
              <i class="heart fa fa-heart" aria-hidden="true"></i>
            {% else %}
              <i class="heart fa fa-heart-o" aria-hidden="true"></i>
            {% endif %}
            <span class="like-count">{{ news.count_likers }}</span>
          </a>
          <span class="timestamp">{{ reply.timestamp|naturaltime }}</span>
        </div>
      </div>
    </div>
  </li>
{% endfor %}

bootcamp/templates/news/news_thread_modal.html
{% load i18n static %}
{% load thumbnail %}

<div class="modal fade" id="newsThreadModal" tabindex="-1" role="dialog" aria-labelledby="newsThreadModalLabel" aria-hidden="true">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Body -->
      <div class="modal-body" >
        <ul class="stream" id="newsContent"></ul>
        <ul class="stream">
          <li class="card">
            <div class="card-body">
              <div class="profile-picture">
                {% thumbnail request.user.picture "x60" as im %}
                  <img src="{{ im.url }}" class="pull-left" style="border-radius: 50%;" alt="{% trans 'User Image' %}" class="user-image">
                {% empty %}
                  <img src="{% static 'img/user.png' %}" class="pull-left" height="60px" alt="{% trans 'No Profile Picture' %}" />
                {% endthumbnail %}
              </div>
              <div class="post">
                <form id="replyNewsForm" role="form" method="post" action="#" onsubmit="return false">
                  {% csrf_token %}
                  <input type="hidden" name="parent" value="">
                  <div class="form-group">
                    <textarea id="replyInput" name="reply" rows="2" class="form-control" maxlength="280"></textarea>
                    <span id="replyCounter" class="pull-right">280</span>
                  </div>
                </form>
              </div>
            </div>
            <div class="card-footer">
              <button type="button" id="replyNews" class="btn btn-primary pull-right">
                <i class="fa fa-paper-plane" aria-hidden="true"></i> {% trans 'Reply' %}
              </button>
            </div>
          </li>
        </ul>
        <ul class="stream" id="threadContent"></ul>
      </div>
      <!-- Body -->
    </div>
  </div>
</div>